import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class Graph3d extends Frame implements ActionListener
{
	
	Canvas drawArea=new Canvas();

	//final int shapeCount=3;
	//final int transCount=2;
	final int MAXPTS=10000;
	final int MAXPOLY=5000;
	final int MaxShapes=20;
	final int MINCOOR=-16000;
	final int NCOLORS=256;
	
	final int ISO=1;
	final int ZBUFFW=400;
	final int ZBUFFH=400;
	
	final int MaxLight=10;
	
	int buffsx=ZBUFFW/2-50,buffsy=0;//ZBUFFH/2-50;
	int width=ZBUFFW+100,height=ZBUFFH;
	int MAXY=ZBUFFH;
	
	int ZBUFF=ZBUFFW*ZBUFFH;
	
	int zbuffer[]=new int[ZBUFF];
	
	int lightno=2;
	DirVector light[]=new DirVector[MaxLight];
	
	
	
	Point3d pts[]=new Point3d[MAXPTS];
	Polygon3d polys[]=new Polygon3d[MAXPOLY];
	//DirVector ptnorm[]=new DirVector[MAXPTS];
	int startx[]=new int[MAXY];
	int startz[]=new int[MAXY];
	int endx[]=new int[MAXY];
	int endz[]=new int[MAXY];
	int stclr[]=new int[MAXY];
	int endclr[]=new int[MAXY];
	
	int ptsno=0,polyno=0;
	Color selColor=new Color(255,255,255);
	Color curColor=new Color(255,255,0);
	Color polyColor;
	
	MenuBar mb=new MenuBar();
	Menu menus[]=new Menu[2];
		
	int curShape=0;
	int curIndex;
	
	String shapePrompt[]={"ObjOfRev","Render","Color"};
	String transPrompt[]={"RotateX","RotateY","RotateZ","Translate"};
	int shapeValue[]={Shape3d.OBJOFREV};
	int transShortcut[]={KeyEvent.VK_X,KeyEvent.VK_Y,KeyEvent.VK_Z,KeyEvent.VK_T};
	int shapeShortcut[]={KeyEvent.VK_O,KeyEvent.VK_E,KeyEvent.VK_C};
	
	Shape3d shapes[]=new Shape3d[MaxShapes];
	
	Label statusLabel=new Label();	
	
	List shapeList=new List();
	
	TextField transXText,transYText,transZText;
	TextField rotAngText;
	Label transXLabel=new Label("X");
	Label transYLabel=new Label("Y");
	Label transZLabel=new Label("Z");
	Label rotAngLabel=new Label("Angle");
	
	int orgX,orgY;
	
	Image backBuffer;

	boolean render=false;
	
	Graph3d(Frame w)
	{
		//super(w,"TwoD Graphics",true);
		super("ThreeD Graphics");
		addWindowListener(new WinAdap());

		setMenuBar(mb);
		setSize(width,height);
		setResizable(false);

		initCockpit(); //Menus
		
		shapeList.addActionListener(this);
		
		statusLabel.setText("Shape :"+shapePrompt[curShape]);

		//This is the drawing surface
	
		transXText=new TextField("0");
		transYText=new TextField("0");
		transZText=new TextField("0");
		rotAngText=new TextField("0");
		
		//Adding the texts for x,y and angle
		Panel transTexts=new Panel();
		transTexts.setLayout(new GridLayout(3,3));
		transTexts.add(transXLabel);
		transTexts.add(transYLabel);
		transTexts.add(transZLabel);
		transTexts.add(transXText);
		transTexts.add(transYText);
		transTexts.add(transZText);
		transTexts.add(rotAngLabel);
		transTexts.add(rotAngText);
		
		drawArea.setBackground(Color.black);

		Panel leftPanel=new Panel();
		leftPanel.setLayout(new BorderLayout());
		leftPanel.add("Center",shapeList);
		leftPanel.add("South",transTexts);

		orgX=ZBUFFW/2;//width/2-50;
		orgY=ZBUFFH/2;//height/2;

		add("North",statusLabel);
		add("Center",drawArea);
		add("West",leftPanel);
				
		curIndex=-1;
/*		
		pts[0]=new Point3d(0,0,0);
		pts[1]=new Point3d(100,0,0);
		pts[2]=new Point3d(100,100,0);
		pts[3]=new Point3d(0,100,0);
		ptsno=4;
		polys[0]=new Polygon3d();
		polys[0].p[0]=0;
		polys[0].p[1]=1;
		polys[0].p[2]=2;
		polys[0].p[3]=3;
		polyno=1;
		shapes[0]=new Shape3d(0,1,curColor.getRGB());
		Point3d tmp=new Point3d();
		rotate(45,pts[3],tmp,new Point3d(),1);
		pts[3]=tmp;
		curShape=1;
*/
		light[0]=new DirVector(.9015,.3010,.3010);
		light[1]=new DirVector(-.9015,-.3010,-.3010);
		light[2]=new DirVector(.577,.577,.577);
		light[3]=new DirVector(1,0,0);
		light[4]=new DirVector(-1,0,0);
//		backBuffer=new Image();
		/*backBuffer=createImage(ZBUFFW+1,ZBUFFH+1);
		if(backBuffer==null)
		{
			System.out.println("Damn it");
			return;
		}
		Graphics g2=backBuffer.getGraphics();
		g2.fillRect(0,0,ZBUFF,ZBUFFH);*/
		setVisible(true);
	}
	
	public void initCockpit()
	{
		int i;
	   menus[0]=new Menu("Shapes");
		for(i=0;i<shapePrompt.length;++i)
			setMenuItem(menus[0],shapePrompt[i],shapeShortcut[i]);
		
		curShape=0;
	
		menus[1]=new Menu("Transforms");
		for(i=0;i<transPrompt.length;++i)
			setMenuItem(menus[1],transPrompt[i],transShortcut[i]);

		for(i=0;i<menus.length;++i)
			mb.add(menus[i]);
	}
	
	public void setMenuItem(Menu m,String s,int key)
	{
		MenuItem mi=new MenuItem(s,new MenuShortcut(key));
		m.add(mi);
		mi.addActionListener(this);
	}

	public void actionPerformed(ActionEvent ae)
	{
		if(ae.getSource()==shapeList)
		{
			curIndex=shapeList.getSelectedIndex();
			repaint();
			return ;
		}
		if(ae.getActionCommand().equals("ObjOfRev"))
		{
			ObjDialog ob=new ObjDialog(this);
			Point3d p[]=ob.objRevCanvas.p;
			int no=ob.objRevCanvas.noOfPts;
			int start=polyno;
			int startp=ptsno;
			Point3d abt=new Point3d(0,0,0);
			ObjOfRev(p,abt,no);
			//System.out.println("No is"+no);
			int end=polyno-1;
			int endp=ptsno-1;
//			System.out.println("Poly is "+polyno);
			shapes[curShape++]=new Shape3d(start,end,startp,endp,curColor.getRGB());
			shapeList.add("Object"+curShape);
			repaint();
		}
		
		if(ae.getActionCommand().equals("Translate"))
		{
			if(curIndex!=-1)
			{
				try
				{
					int tx=Integer.parseInt(transXText.getText());
					int ty=Integer.parseInt(transYText.getText());
					int tz=Integer.parseInt(transZText.getText());
					if(curIndex!=-1)
					{
						//drawArea.erase(curIndex);
						shapes[curIndex].translate(this,tx,ty,tz);
						repaint();
					}
				}
				catch(Exception e)
				{
					return ;
				}
		
				return;
			}
		}
		
		if(ae.getActionCommand().equals("RotateX"))
		{
			if(curIndex!=-1)
			{
				try
				{
					int tx=Integer.parseInt(transXText.getText());
					int ty=Integer.parseInt(transYText.getText());
					int tz=Integer.parseInt(transZText.getText());
					double ang=Double.parseDouble(rotAngText.getText());
					Point3d abtpt=new Point3d(tx,ty,tz);
					if(curIndex!=-1)
					{
						//drawArea.erase(curIndex);
						shapes[curIndex].rotate(this,ang,abtpt,3);
						repaint();
					}
				}
				catch(Exception e)
				{
					return ;
				}
		
				return;
			}
		}
		if(ae.getActionCommand().equals("RotateY"))
		{
			if(curIndex!=-1)
			{
				try
				{
					int tx=Integer.parseInt(transXText.getText());
					int ty=Integer.parseInt(transYText.getText());
					int tz=Integer.parseInt(transZText.getText());
					double ang=Double.parseDouble(rotAngText.getText());
					Point3d abtpt=new Point3d(tx,ty,tz);
					if(curIndex!=-1)
					{
						//drawArea.erase(curIndex);
						shapes[curIndex].rotate(this,ang,abtpt,2);
						repaint();
					}
				}
				catch(Exception e)
				{
					return ;
				}
		
				return;
			}
		}
		if(ae.getActionCommand().equals("RotateZ"))
		{
			if(curIndex!=-1)
			{
				try
				{
					int tx=Integer.parseInt(transXText.getText());
					int ty=Integer.parseInt(transYText.getText());
					int tz=Integer.parseInt(transZText.getText());
					double ang=Double.parseDouble(rotAngText.getText());
					Point3d abtpt=new Point3d(tx,ty,tz);
					if(curIndex!=-1)
					{
						//drawArea.erase(curIndex);
						shapes[curIndex].rotate(this,ang,abtpt,1);
						repaint();
					}
				}
				catch(Exception e)
				{
					return ;
				}
		
				return;
			}
		}
		
		if(ae.getActionCommand().equals("Render"))
		{
			renderScene();
			return;
		}
		if(ae.getActionCommand().equals("Color"))
		{
			Color tmp=JColorChooser.showDialog(this,"Pick a color",curColor);
			if(tmp!=null) curColor=tmp;
		}
	
	}
	
	public void paint(Graphics g)
	{
		int i;
		if(render==true)
		{
			render=false;
			drawArea.getGraphics().drawImage(backBuffer,0,0,this);
			return;
		}
			
		Graphics g2=drawArea.getGraphics();
		g2.fillRect(0,0,ZBUFFW,ZBUFFH);
		Point3d org=new Point3d(0,0,0);
		Point3d p1=new Point3d(100,0,0);
		line3d(g2,org,p1,Color.blue.getRGB());
		p1.x=0;
		p1.y=100;
		line3d(g2,org,p1,Color.blue.getRGB());
		p1.y=0;
		p1.z=100;
		line3d(g2,org,p1,Color.blue.getRGB());
		for(i=0;i<curShape;++i)
		{
			if(curIndex!=i)
				shapes[i].draw(g2,this);
		}
		if(curIndex!=-1)	shapes[curIndex].contdraw(g2,this,selColor.getRGB());
	}
	
	public void ObjOfRev(Point3d rev[],Point3d abt,int n)
	{
		Point3d tmp=new Point3d(0,0,0);
		int ang=10;
		int i,j;
		for(j=0;j<n;++j)
		{
			pts[ptsno++]=new Point3d(rev[j].x,rev[j].y,rev[j].z);
//			addPoint(rev[j].x,rev[j].y,rev[j].z);
		}
		for(i=ang;i<=360;i+=ang)
		{
			for(j=0;j<n;++j)
		   {
		      rotate(i,rev[j],tmp,abt,1);
		      pts[ptsno]=new Point3d();
		      pts[ptsno].x=tmp.x;
		      pts[ptsno].y=tmp.y;
				  pts[ptsno].z=tmp.z;
					++ptsno;
		   }
		   for(j=n;j>1;--j)
		   {
		   	 polys[polyno]=new Polygon3d(this,ptsno-(n+j),ptsno-(n+j-1),ptsno- (j-1),ptsno-j,curColor.getRGB());
				 /*polys[polyno].p[0]=ptsno-(n+j);
		   	 polys[polyno].p[1]=ptsno-(n+j-1);
		     polys[polyno].p[2]=ptsno- (j-1);
		     polys[polyno].p[3]=ptsno-j;*/
		     ++polyno;
		   }
		}
	}
	
/*	public void update(Graphics g)
	{
		paint(g);
	}
*/

	public void renderScene()
	{
		int i,x,y;
		
		System.out.println("In Rendering");
		backBuffer=createImage(ZBUFFW+1,ZBUFFH+1);
		Graphics g2=backBuffer.getGraphics();
		g2.setColor(Color.black);
		g2.fillRect(0,0,ZBUFFW,ZBUFFH);
		initZBuffer();
  	calcColor();
  	for(i=0;i<polyno;++i)
    {
	  	ShadePoly(polys[i]);
  	}
  	render=true;
  	repaint();
    /*for(x=0;x<100;++x)
      	for(y=0;y<100;++y)
					Putpixel(x,y,color[x*100+y]);*/
	}
	
	public void initZBuffer()
	{
		int i;
	  for(i=0;i<ZBUFF;++i)
  	  zbuffer[i]=-2147483648;
	}
	
	public void ShadePoly(Polygon3d p)
	{
	  double tx,ty,tz;
	  double icomp,jcomp,kcomp;
	  double fclr;
	  int clr;
	  int clrs[]=new int[4];
	  //double x[]=new double[4],y[]=new double[4],z[]=new double[4];
	  int x[]=new int[4],y[]=new int[4],z[]=new int[4];
	  int nopts=0;
	  int i,k;
	  
	  for(i=0;i<MAXY;++i)
	    startx[i]=MINCOOR;
	    
	  polyColor=new Color(p.color);
	  Point3d tmp=new Point3d();
	  for(i=0;i<4;++i)
	  {
	    projrot(pts[p.p[i]],tmp,ISO);
	    x[i]=(int)(tmp.x);
	    y[i]=(int)(tmp.y);
	    z[i]=(int)tmp.z;
	    clrs[i]=pts[p.p[i]].color;
			++nopts;	  
		}
	  
	  for(i=1;i<nopts;++i)
	  {
	    scanconvert(x[i-1],y[i-1],z[i-1],x[i],y[i],z[i],clrs[i-1],clrs[i]);
	  }
	  scanconvert(x[nopts-1],y[nopts-1],z[nopts-1],x[0],y[0],z[0],clrs[3],clrs[0]);
	  for(i=0;i<MAXY;++i)
	  {
	    if(startx[i]!=MINCOOR)
	      shadeline(i,startx[i],startz[i],endx[i],endz[i],stclr[i],endclr[i]);
	  }
	}
	
	public void scanconvert(int x1,int y1,int z1,int x2,int y2,int z2,int sclr,int eclr)
	{
	  int tmp,y;
	  long x,z,m,m1,clr,clrgrad;
	  
	  if (y2 != y1)     /* This isn't a horizontal line */
	  {
	    if (y2 < y1)    /* Make sure y2 is greater than y1 */
	    {
	      tmp = y1;      /* Swap the y coordinate */
	      y1 = y2;
	      y2 = tmp;
	
	      tmp = x1;      /* Swap the corresponding x coordinates */
	      x1 = x2;
	      x2 = tmp;
	
	      tmp = z1;      /* Swap the corresponding z coordinates */
	      z1 = z2;
	      z2 = tmp;
	
	      tmp=sclr;
	      sclr=eclr;
	      eclr=tmp;
	    }
	    x = (long)x1<<8;  /* Multiply be 256 */
	    z = (long)z1<<8;
	    clr=(long) sclr<<8;
	
	    m = ((long)(x2 - x1)<<8) / ((long)(y2 - y1));
	    m1= ((long)(z2 - z1)<<8) / ((long)(y2 - y1));
	    clrgrad=((long)(eclr-sclr)<<8)/((long)(y2-y1));
	    /* m is the fractional amount to add to the x coordinate every row.
	       m is equal to (delta x) / (delta y).  In other words, the x coordinate
		has to change by (x2 - x1) columns in (y2 - y1) rows. */
	
	    x += m; /* We ALWAYS skip the first point in every line. This is done */
	    z += m1;
	    clr+=clrgrad;
	    y1++;  /* because we do not want to store the point where two lines
		  meet, twice.  This would result in a single point being drawn. */
	
	    for (y = y1; y <= y2; y++) /* Go through each row */
	    {
	      if ((y >= 0) & (y < MAXY)) /* If the coordinate is on the screen */
					if (startx[y] == MINCOOR) /* Store the first coordinate */
					{
					  startx[y] = (int)(x>>8);
					  startz[y] = (int)(z>>8);
					  stclr[y]=(int)(clr>>8);
					}
					else
					{
					  endx[y] = (int)x>>8;        /* Store the last coordinate */
					  endz[y] = (int)z>>8;
					  endclr[y] = (int)clr>>8;
					}
		      x += m;                   /* Add our constant to x */
		      z += m1;
		      clr+=clrgrad;
	    }
	  }
	  else
	  {
	  	if ((y1 >= 0) & (y1 < MAXY)) 
	  	{
	    	startx[y1] = x1;
	    	startz[y1] = z1;
	    	endx[y1] = x2;        /* Store the last coordinate */
	    	endz[y1] = z2;
	    	stclr[y1]=sclr;
	    	endclr[y1]=eclr;
	    }
	  }
	}

	public void shadeline(int y,int x1,int z1,int x2,int z2,int sclr,int eclr)
	{
	  int tmp,x;
	  long z,m;
	  long clr,clrgrad;
	  int r,gr,b;
	  
	  r=polyColor.getRed();
	  gr=polyColor.getGreen();
	  b=polyColor.getBlue();

 	  Graphics g=backBuffer.getGraphics();

	  if (x2 != x1)     /* This isn't a horizontal line */
	  {
	    if (x2 < x1)    /* Make sure x2 is greater than x1 */
	    {
	      tmp = x1;      /* Swap the x coordinate */
	      x1 = x2;
	      x2 = tmp;
	
	      tmp = z1;      /* Swap the corresponding z coordinates */
	      z1 = z2;
	      z2 = tmp;
	
	      tmp=sclr;
	      sclr=eclr;
	      eclr=tmp;
	
	    }
	    z = (long)z1<<8;  /* Multiply be 256 */
	    clr=(long)sclr<<8;
	    m = ((long)(z2 - z1)<<8) / ((long)(x2 - x1));
	    clrgrad=((long)(eclr - sclr)<<8) / ((long)(x2 - x1));
	    for (x = x1; x <= x2; x++)
	    {
	    	
	      if(x>=0 && y>=0 && x<ZBUFFW && y<ZBUFFH)
	      {
					if(zbuffer[x*ZBUFFW+y]<=(z>>8))
					{
					  zbuffer[x*ZBUFFW+y]=(int)(z>>8);
					  //color[x*ZBUFFW+y]=clr>>8;
					  g.setColor(new Color((int)((r/255.0)*(clr >>8)),(int)((gr/255.0)*(clr >>8)),(int)((b/255.0)*(clr >>8))));
						//g.drawLine(x-buffsx,buffsy-y,x-buffsx,buffsy-y);
						g.drawLine(x,y,x,y);

					}
	      }
	      z += m;
	      clr+=clrgrad;
	    }
	  }
	  else
	  {
	    x=x1;
	    z=z1<<8;
	    clr=sclr<<8;
	    if(x>=0 && y>=0 && x<ZBUFFW && y<ZBUFFH)
	    {
	      if(zbuffer[x*ZBUFFW+y]<=(z>>8))
	      {
					zbuffer[x*ZBUFFW+y]=(int)(z>>8);
					//color[x*ZBUFFW+y]=clr>>8;
					//g.setColor(new Color((int)(clr >>8),0,0));
					//g.setColor(new Color((r/255.0)*(clr >>8),(gr/255.0)*(clr >>8),(b/255.0)*(clr >>8)));
				  g.setColor(new Color((int)((r/255.0)*(clr >>8)),(int)((gr/255.0)*(clr >>8)),(int)((b/255.0)*(clr >>8))));

					//g.drawLine(x-buffsx,buffsy-y,x-buffsx,buffsy-y);
					g.drawLine(x,y,x,y);

	      }
	    }
	  }
	}
	
	public void calcColor()
	{
		int i,j;
		double fclr;
		double iv,jv,kv;
		for(i=0;i<ptsno;++i)
		{
			iv=pts[i].norm.i/pts[i].polycnt;
     	jv=pts[i].norm.j/pts[i].polycnt;
     	kv=pts[i].norm.k/pts[i].polycnt;
   		pts[i].color=0;
   		for(j=0;j<lightno;++j)
     	{
     		fclr=(iv*light[j].i+jv*light[j].j+kv*light[j].k)/Math.sqrt(iv*iv+jv*jv+kv*kv);
      	fclr*=NCOLORS;
       	if(fclr>0)
	 				if(pts[i].color+Math.abs(fclr)>NCOLORS)
	   				pts[i].color=NCOLORS;
	 				else
	   				pts[i].color+=Math.abs(fclr);
     	}
		}
	}
	

	public void rotate(double angle,Point3d input,Point3d output,Point3d aboutpt,int aboutaxis)
	{
		angle=angle*3.14/180;
		switch(aboutaxis)
		{
		  case 1: // About Z axis
		    output.x=aboutpt.x+((double)(input.x-aboutpt.x))*Math.cos(angle)+((double)(input.y-aboutpt.y))*Math.sin(angle);
    	    output.y=aboutpt.y+((double)(input.y-aboutpt.y))*Math.cos(angle)-((double)(input.x-aboutpt.x))*Math.sin(angle);
		    output.z=input.z;
	//	    System.out.println("Rot "+output.x+" " +output.y+" "+output.z);
          break;
		  case 2: //About Y axis
		    output.z=aboutpt.z+((double)(input.z-aboutpt.z))*Math.cos(angle)+((double)(input.x-aboutpt.x))*Math.sin(angle);
		    output.x=aboutpt.x+((double)(input.x-aboutpt.x))*Math.cos(angle)-((double)(input.z-aboutpt.z))*Math.sin(angle);
		    output.y=input.y;
		    break;
		  case 3:  //About X axis
		    output.y=aboutpt.y+((double)(input.y-aboutpt.y))*Math.cos(angle)+((double)(input.z-aboutpt.z))*Math.sin(angle);
		    output.z=aboutpt.z+((double)(input.z-aboutpt.z))*Math.cos(angle)-((double)(input.y-aboutpt.y))*Math.sin(angle);
		    output.x=input.x;
		    break;
		}
	}
	
	public void projrot(Point3d in,Point3d p,int type)
	{
	  double tempy,tempx,tempz;
	  double x,y,z;
	  x=in.x;y=in.y;z=in.z;
	  switch(type)
	  {
	  case 1:
	    /*Iso Metric- View the object after rotating 45 deg about z axis
	    and rotating 35.26 about y axis*/
	    tempx=y*.707106781-x*.707106781;
	    tempy=-y*.408204055+z*.816540811-x*.408204055;
	    tempz=-y*.577381545+y*0.577287712+z*.577381545;
//	    System.out.println(tempx+" "+tempy+" "+tempz+" "+(orgX+tempx)+" "+(orgY-tempy));
//	    x2d=tempx;//320+
//	    y2d=-tempy;//200-
//	    z2d=tempz;
	    p.x=orgX+tempx;
	    p.y=orgY-tempy;
	    p.z=tempz;
	    break;
	  case 2:
	    break;
	  case 3:
	    break;
	  }
	}
	
	public void Plot3d(Graphics g,Point3d p,int clr)
	{
	  double x1,y1;
	  Point3d np=new Point3d(0,0,0);
	  projrot(p,np,ISO);
	  g.setColor(new Color(clr));
	  g.drawLine((int)np.x,(int)np.y,(int)np.x,(int)np.y);
	}
	
	void line3d(Graphics g,Point3d p1,Point3d p2,int clr)
	{
	  float tx1,ty1,tx2,ty2;
	  Point3d np1=new Point3d(),np2=new Point3d();
	  projrot(p1,np1,ISO);
	  projrot(p2,np2,ISO);
	  g.setColor(new Color(clr));
	  g.drawLine((int)np1.x,(int)np1.y,(int)np2.x,(int)np2.y);
	}
	public void drawPoly(Graphics g,Polygon3d p,int clr)
	{
	  int i;
	  Point3d pt=new Point3d(),pt0=new Point3d();
	  float x,y,x0,y0;
	  for(i=0;i<3;++i)
	  {
	    if(p.p[i+1]<0) {break;}
	    //System.out.println("poly"+p.p[i]+pts[p.p[i]].x+" "+pts[p.p[i]].y+" "+pts[p.p[i]].z);
	    //projrot(pts[p.p[i]],pt0,ISO);
	    //projrot(pts[p.p[i+1]],pt,ISO);
	    line3d(g,pts[p.p[i]],pts[p.p[i+1]],clr);
	  }
     //System.out.println("poly"+p.p[i]);
	  line3d(g,pts[p.p[i]],pts[p.p[0]],clr);
	}	
  	
	public class WinAdap extends WindowAdapter
	{	
		public void windowClosing(WindowEvent e)
		{
			hide();
		}
	}
}