import java.awt.*;


public class MyPolygon extends Shape2d
{
	int noOfPts=0;
	int color;
	double x[],y[];
	public  MyPolygon(int clr)
	{
		color=clr;
		x=new double[10];
		y=new double[10];
		noOfPts=0;
		type=POLYGON;
	}
	public void rotate(float ang,int prx,int pry)
	{
		double tx,ty;
		double rx=prx;
		double ry=pry;
		double a=(double)ang*3.14/180;
		for(int i=0;i<noOfPts;++i)
		{
			tx=rx+(x[i]-rx)*Math.cos(a)+(y[i]-ry)*Math.sin(a);
			ty=ry+(y[i]-ry)*Math.cos(a)-(x[i]-ry)*Math.sin(a);
			x[i]=tx;
			y[i]=ty;
		}
		
	}
	public void translate(int rx,int ry)
	{
		for(int i=0;i<noOfPts;++i)
		{
			x[i]+=(double)rx;
			y[i]+=(double)ry;
		}
	}
	public void draw(Graphics g,int orgx,int orgy)
	{
		if(noOfPts<=1) return;
		g.setPaintMode();
		g.setColor(new Color(color));
		for(int i=0;i<noOfPts-1;++i)
		{
			g.drawLine((int)(x[i]+orgx),(int)(orgy-y[i]),(int)(x[(i+1)]+orgx),(int)(orgy-y[(i+1)]));
		}
	}

	public void contdraw(Graphics g,int orgx,int orgy)
	{
		if(noOfPts<=1) return;
		for(int i=0;i<noOfPts-1;++i)
		{
			g.drawLine((int)(x[i]+orgx),(int)(orgy-y[i]),(int)(x[i+1]+orgx),(int)(orgy-y[(i+1)]));
		}
	
	}
	
	public void addPoint(int x,int y)
	{
		double tx[]=new double[noOfPts+1];
		double ty[]=new double[noOfPts+1];
		int i;
		for(i=0;i<noOfPts;++i)
		{
			tx[i]=this.x[i];
			ty[i]=this.y[i];
		}
		tx[i]=x;
		ty[i]=y;
		noOfPts++;
		this.x=tx;
		this.y=ty;
	}
	
	public void mirrorX()
	{
		for(int i=0;i<noOfPts;++i)
		{
			y[i]=-y[i];
		}
	}
	public void mirrorY()
	{
		for(int i=0;i<noOfPts;++i)
		{
			x[i]=-x[i];
		}
	}
	
	public void clip(double l,double t,double r,double b)
	{
		double tx[]=new double[100],ty[]=new double[100];
		int tcnt=0,i;
		double m;
		System.out.println("In here");
		//Left Clipping
		for(i=0;i<noOfPts;++i)
		{
			System.out.println("In here");
			m=(y[(i+1)%noOfPts]-y[i])/(x[(i+1)%noOfPts]-x[i]);
			if(x[i]<l && x[(i+1)%noOfPts]<l) continue;
			if(x[i]<l && x[i+1]>=l)
			{
				tx[tcnt]=l;
				ty[tcnt]=m*(l-x[i])+y[i];
				++tcnt;
				tx[tcnt]=x[(i+1)%noOfPts];
				ty[tcnt]=y[(i+1)%noOfPts];
				++tcnt;
				continue;
			}
			if(x[i]>=l && x[(i+1)%noOfPts]>=l)
			{
				tx[tcnt]=x[(i+1)%noOfPts];
				ty[tcnt]=y[(i+1)%noOfPts];
				tcnt++;
				continue;
			}
			if(x[i]>=l && x[(i+1)%noOfPts]<l)
			{
				tx[tcnt]=l;
				ty[tcnt]=m*(l-x[i])+y[i];
				tcnt++;
				continue;
			}
		}	
		tx[tcnt]=tx[0];
		ty[tcnt]=ty[0];
		noOfPts=tcnt+1;
		x=tx;
		y=ty;
	
		tx=new double[100];
		ty=new double[100];
		//Right Clipping
		tcnt=0;
		for(i=0;i<noOfPts;++i)
		{
			m=(y[(i+1)%noOfPts]-y[i])/(x[(i+1)%noOfPts]-x[i]);
			if(x[i]>r && x[(i+1)%noOfPts]>r) continue;
			if(x[i]<=r && x[(i+1)%noOfPts]>r) 
			{
				tx[tcnt]=r;
				ty[tcnt]=m*(r-x[i])+y[i];
				tcnt++;
				continue;
			}
			if(x[i]>r && x[(i+1)%noOfPts]<=r) 
			{
				tx[tcnt]=r;
				ty[tcnt]=m*(r-x[i])+y[i];
				tcnt++;
				tx[tcnt]=x[(i+1)%noOfPts];
				ty[tcnt]=y[(i+1)%noOfPts];
				++tcnt;
				continue;
			}			
			if(x[i]<=r && x[(i+1)%noOfPts]<=r)
			{
				tx[tcnt]=x[(i+1)%noOfPts];
				ty[tcnt]=y[(i+1)%noOfPts];
				++tcnt;
				continue;
			}
		}
		tx[tcnt]=tx[0];
		ty[tcnt]=ty[0];
		noOfPts=tcnt+1;
		x=tx;
		y=ty;
		
		tx=new double[100];
		ty=new double[100];
		//Bottom Clipping
		tcnt=0;
		for(i=0;i<noOfPts;++i)
		{
			m=(y[(i+1)%noOfPts]-y[i])/(x[(i+1)%noOfPts]-x[i]);
			if(y[i]<b && y[(i+1)%noOfPts]<b) continue;
			if(y[i]<b && y[(i+1)%noOfPts]>=b)
			{
				tx[tcnt]=1/m*(b-y[i])+x[i];
				ty[tcnt]=b;
				++tcnt;
				tx[tcnt]=x[(i+1)%noOfPts];
				ty[tcnt]=y[(i+1)%noOfPts];
				++tcnt;
			}
			if(y[i]>=b && y[(i+1)%noOfPts]<b)
			{
				tx[tcnt]=1/m*(b-y[i])+x[i];
				ty[tcnt]=b;
				++tcnt;
			}
			if(y[i]>=b && y[(i+1)%noOfPts]>=b)
			{
				tx[tcnt]=x[(i+1)%noOfPts];
				ty[tcnt]=y[(i+1)%noOfPts];
				++tcnt;
			}			
			
		}
		tx[tcnt]=tx[0];
		ty[tcnt]=ty[0];
		noOfPts=tcnt+1;
		x=tx;
		y=ty;
		
		tx=new double[100];
		ty=new double[100];
		//Top Clipping
		tcnt=0;
		for(i=0;i<noOfPts;++i)
		{
			m=(y[(i+1)%noOfPts]-y[i])/(x[(i+1)%noOfPts]-x[i]);
			if(y[i]>t && y[(i+1)%noOfPts]>t) continue;
			if(y[i]>t && y[(i+1)%noOfPts]<=t)
			{
				tx[tcnt]=1/m*(t-y[i])+x[i];
				ty[tcnt]=t;
				++tcnt;
				tx[tcnt]=x[(i+1)%noOfPts];
				ty[tcnt]=y[(i+1)%noOfPts];
				++tcnt;
			}
			if(y[i]<=t && y[(i+1)%noOfPts]>t)
			{
				tx[tcnt]=1/m*(t-y[i])+x[i];
				ty[tcnt]=t;
				++tcnt;
			}
			if(y[i]<=t && y[(i+1)%noOfPts]<=t)
			{
				tx[tcnt]=x[(i+1)%noOfPts];
				ty[tcnt]=y[(i+1)%noOfPts];
				++tcnt;
			}			
			
		}
		tx[tcnt]=tx[0];
		ty[tcnt]=ty[0];
		noOfPts=tcnt+1;
		x=tx;
		y=ty;				
	}	
}